diff --git a/web/pgadmin/static/js/components/FormComponents.jsx b/web/pgadmin/static/js/components/FormComponents.jsx
index cdcfab64..7f69bcf4 100644
--- a/web/pgadmin/static/js/components/FormComponents.jsx
+++ b/web/pgadmin/static/js/components/FormComponents.jsx
@@ -941,20 +962,20 @@ export function InputColor({value, controlProps, disabled, onChange, currObj}) {
       setColor(value);
       disabled && instance.disable();
 
-      const {lastColor} = instance.getRoot().preview;
-      const {clear} = instance.getRoot().interaction;
+      const { lastColor } = instance.getRoot().preview;
+      const { clear } = instance.getRoot().interaction;
 
       /* Cycle the keyboard navigation within the color picker */
-      clear.addEventListener('keydown', (e)=>{
-        if(e.keyCode === 9) {
+      clear.addEventListener('keydown', (e) => {
+        if (e.keyCode === 9) {
           e.preventDefault();
           e.stopPropagation();
           lastColor.focus();
         }
       });
 
-      lastColor.addEventListener('keydown', (e)=>{
-        if(e.keyCode === 9 && e.shiftKey) {
+      lastColor.addEventListener('keydown', (e) => {
+        if (e.keyCode === 9 && e.shiftKey) {
           e.preventDefault();
           e.stopPropagation();
           clear.focus();
@@ -965,32 +986,32 @@ export function InputColor({value, controlProps, disabled, onChange, currObj}) {
     }).on('change', (color) => {
       onChange && onChange(color.toHEXA().toString());
     }).on('show', (color, instance) => {
-      const {palette} = instance.getRoot().palette;
+      const { palette } = instance.getRoot().palette;
       palette.focus();
     }).on('hide', (instance) => {
       const button = instance.getRoot().button;
       button.focus();
     });
 
-    if(currObj) {
+    if (currObj) {
       currObj(pickrObj.current);
     }
   };
 
-  useEffect(()=>{
+  useEffect(() => {
     initPickr();
-    return ()=>{
+    return () => {
       destroyPickr();
     };
   }, [...Object.values(pickrOptions)]);
 
-  useEffect(()=>{
-    if(pickrObj.current) {
+  useEffect(() => {
+    if (pickrObj.current) {
       setColor(value);
     }
   }, [value]);
 
-  let btnStyles = {backgroundColor: value};
+  let btnStyles = { backgroundColor: value };
   return (
     <PgIconButton ref={eleRef} title={gettext('Select the color')} className={classes.colorBtn} style={btnStyles} disabled={pickrOptions.disabled}
       icon={(_.isUndefined(value) || _.isNull(value) || value === '') && <CloseIcon />}
@@ -1006,11 +1027,11 @@ InputColor.propTypes = {
 };
 
 export function FormInputColor({
-  hasError, required, className, label, helpMessage, testcid, ...props}) {
+  hasError, required, className, label, helpMessage, testcid, ...props }) {
 
   return (
     <FormInput required={required} label={label} error={hasError} className={className} helpMessage={helpMessage} testcid={testcid}>
-      <InputColor {...props}/>
+      <InputColor {...props} />
     </FormInput>
   );
 }
@@ -1023,9 +1044,9 @@ FormInputColor.propTypes = {
   testcid: PropTypes.string,
 };
 
-export function PlainString({controlProps, value}) {
+export function PlainString({ controlProps, value }) {
   let finalValue = value;
-  if(controlProps?.formatter) {
+  if (controlProps?.formatter) {
     finalValue = controlProps.formatter.fromRaw(finalValue);
   }
   return <span>{finalValue}</span>;
@@ -1035,7 +1056,7 @@ PlainString.propTypes = {
   value: PropTypes.any,
 };
 
-export function FormNote({text, className}) {
+export function FormNote({ text, className }) {
   const classes = useStyles();
   return (
     <Box className={className}>
@@ -1051,7 +1072,7 @@ FormNote.propTypes = {
   className: CustomPropTypes.className,
 };
 
-const useStylesFormFooter = makeStyles((theme)=>({
+const useStylesFormFooter = makeStyles((theme) => ({
   root: {
     padding: theme.spacing(0.5),
     position: 'absolute',
@@ -1108,7 +1129,7 @@ const useStylesFormFooter = makeStyles((theme)=>({
 export function FormFooterMessage(props) {
   const classes = useStylesFormFooter();
 
-  if(!props.message) {
+  if (!props.message) {
     return <></>;
   }
   return (
@@ -1122,15 +1143,54 @@ FormFooterMessage.propTypes = {
   message: PropTypes.string,
 };
 
-export function NotifierMessage({type=MESSAGE_TYPE.SUCCESS, message, closable=true, onClose=()=>{/*This is intentional (SonarQube)*/}}) {
+export function FormInputKeyboardShortcut({ hasError, label, className, helpMessage, testcid, onChange, ...props }) {
+  const cid = _.uniqueId('c');
+  const helpid = `h${cid}`;
+  return (
+    <FormInput label={label} error={hasError} className={className} helpMessage={helpMessage} testcid={testcid}>
+      <KeyboardShortcuts cid={cid} helpid={helpid} onChange={onChange} {...props} />
+    </FormInput>
+
+  );
+}
+FormInputKeyboardShortcut.propTypes = {
+  hasError: PropTypes.bool,
+  label: PropTypes.string,
+  className: CustomPropTypes.className,
+  helpMessage: PropTypes.string,
+  testcid: PropTypes.string,
+  onChange: PropTypes.func
+};
+
+export function FormInputQueryThreshold({ hasError, label, className, helpMessage, testcid, onChange, ...props }) {
+  const cid = _.uniqueId('c');
+  const helpid = `h${cid}`;
+  return (
+    <FormInput label={label} error={hasError} className={className} helpMessage={helpMessage} testcid={testcid}>
+      <QueryThresholds cid={cid} helpid={helpid} onChange={onChange} {...props} />
+    </FormInput>
+
+  );
+}
+FormInputQueryThreshold.propTypes = {
+  hasError: PropTypes.bool,
+  label: PropTypes.string,
+  className: CustomPropTypes.className,
+  helpMessage: PropTypes.string,
+  testcid: PropTypes.string,
+  onChange: PropTypes.func
+};
+
+
+export function NotifierMessage({ type = MESSAGE_TYPE.SUCCESS, message, closable = true, onClose = () => {/*This is intentional (SonarQube)*/ } }) {
   const classes = useStylesFormFooter();
 
   return (
     <Box className={clsx(classes.container, classes[`container${type}`])}>
-      <FormIcon type={type} className={classes[`icon${type}`]}/>
+      <FormIcon type={type} className={classes[`icon${type}`]} />
       <Box className={classes.message}>{message}</Box>
       {closable && <IconButton className={clsx(classes.closeButton, classes[`icon${type}`])} onClick={onClose}>
-        <FormIcon close={true}/>
+        <FormIcon close={true} />
       </IconButton>}
     </Box>
   );
diff --git a/web/pgadmin/static/js/components/KeyboardShortcuts.jsx b/web/pgadmin/static/js/components/KeyboardShortcuts.jsx
new file mode 100644
index 00000000..76aed7cb
--- /dev/null
+++ b/web/pgadmin/static/js/components/KeyboardShortcuts.jsx
@@ -0,0 +1,103 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import _ from 'lodash';
+import { FormGroup, FormControlLabel, makeStyles } from '@material-ui/core';
+import React from 'react';
+import { InputCheckbox, InputText } from './FormComponents';
+import PropTypes from 'prop-types';
+
+const useStyles = makeStyles(() => ({
+  formControlLabel: {
+    padding: '3px',
+  },
+  formInput: {
+    marginLeft: '5px'
+  },
+  formCheckboxControl: {
+    padding: '3px',
+    border: '1px solid',
+    borderRadius: '0.25rem',
+  },
+  formGroup: {
+    padding: '5px'
+  }
+}));
+
+export default function KeyboardShortcuts({ value, onChange, fields }) {
+  const classes = useStyles();
+  const keyCid = _.uniqueId('c');
+  const keyhelpid = `h${keyCid}`;
+  const shiftCid = _.uniqueId('c');
+  const shifthelpid = `h${shiftCid}`;
+  const ctrlCid = _.uniqueId('c');
+  const ctrlhelpid = `h${ctrlCid}`;
+  const altCid = _.uniqueId('c');
+  const althelpid = `h${altCid}`;
+
+  const onKeyDown = (e) => {
+    let newVal = { ...value };
+    let _val = e.key;
+    if (e.keyCode == 32) {
+      _val = 'Space';
+    }
+    newVal.key = {
+      char: _val,
+      key_code: e.keyCode
+    };
+    onChange(newVal);
+  };
+
+  const onShiftChange = (e) => {
+    let newVal = { ...value };
+    newVal.shift = e.target.checked;
+    onChange(newVal);
+  };
+
+  const onCtrlChange = (e) => {
+    let newVal = { ...value };
+    newVal.ctrl = e.target.checked;
+    onChange(newVal);
+  };
+
+  const onAltChange = (e) => {
+    let newVal = { ...value };
+    newVal.alt = e.target.checked;
+    onChange(newVal);
+  };
+
+  return (
+    <FormGroup row={true} className={classes.formGroup}>
+      {fields.map(element => {
+        if (element.type == 'keyCode') {
+          return <FormControlLabel  key={_.uniqueId('c')} labelPlacement="start" className={classes.formControlLabel} control={<InputText cid={keyCid} helpid={keyhelpid} type='text' value={value?.key?.char} controlProps={
+            {
+              onKeyDown: onKeyDown,
+            }
+          }></InputText>} label={element.label} />;
+        } else if (element.name == 'shift') {
+          return <FormControlLabel key={_.uniqueId('c')} labelPlacement="start" className={classes.formCheckboxControl} control={<InputCheckbox cid={shiftCid} helpid={shifthelpid} value={value?.shift} onChange={onShiftChange}></InputCheckbox>} label={element.label} />;
+        } else if (element.name == 'control') {
+          return <FormControlLabel key={_.uniqueId('c')} labelPlacement="start" className={classes.formCheckboxControl} control={<InputCheckbox cid={ctrlCid} helpid={ctrlhelpid} value={value?.ctrl} onChange={onCtrlChange} ></InputCheckbox>} label={element.label} />;
+        } else if (element.name == 'alt') {
+          return <FormControlLabel key={_.uniqueId('c')} labelPlacement="start" className={classes.formCheckboxControl} control={<InputCheckbox cid={altCid} helpid={althelpid} value={value?.alt} onChange={onAltChange}></InputCheckbox>} label={element.label} />;
+        }
+      })
+
+      }
+    </FormGroup>
+  );
+}
+
+KeyboardShortcuts.propTypes = {
+  value: PropTypes.object,
+  onChange: PropTypes.func,
+  controlProps: PropTypes.object,
+  fields: PropTypes.array
+};
diff --git a/web/pgadmin/static/js/components/QueryThresholds.jsx b/web/pgadmin/static/js/components/QueryThresholds.jsx
new file mode 100644
index 00000000..16f5ca76
--- /dev/null
+++ b/web/pgadmin/static/js/components/QueryThresholds.jsx
@@ -0,0 +1,67 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import _ from 'lodash';
+import { FormGroup, FormControlLabel, makeStyles } from '@material-ui/core';
+import React from 'react';
+import { InputText } from './FormComponents';
+import PropTypes from 'prop-types';
+
+const useStyles = makeStyles(() => ({
+  formControlLabel: {
+    padding: '3px',
+  },
+  formInput: {
+    marginLeft: '5px'
+  },
+  formCheckboxControl: {
+    padding: '3px',
+    border: '1px solid',
+    borderRadius: '0.25rem',
+  },
+  formGroup: {
+    padding: '5px'
+  }
+}));
+
+export default function QueryThresholds({ value, onChange }) {
+  const classes = useStyles();
+  const warningCid = _.uniqueId('c');
+  const warninghelpid = `h${warningCid}`;
+  const alertCid = _.uniqueId('c');
+  const alerthelpid = `h${alertCid}`;
+  
+  const onWarningChange = (val) => {
+    let new_val = {...value};
+    new_val['warning'] = val;
+    onChange(new_val);
+  };
+
+  const onAlertChange = (val) => {
+    let new_val = {...value};
+    new_val['alert'] = val;
+    onChange(new_val);
+  };
+
+  return (
+    <FormGroup row={true} className={classes.formGroup}>
+      <FormControlLabel  key={_.uniqueId('c')} labelPlacement="start" className={classes.formControlLabel} control={<InputText cid={warningCid} helpid={warninghelpid} type='numeric' value={value?.warning}
+        onChange={onWarningChange}
+      ></InputText>} label={gettext('Warning')} />;
+      <FormControlLabel  key={_.uniqueId('c')} labelPlacement="start" className={classes.formControlLabel} control={<InputText cid={alertCid} helpid={alerthelpid} type='numeric' value={value?.alert} 
+        onChange={onAlertChange}></InputText>} label={gettext('Alert')} />;
+    </FormGroup>
+  );
+}
+
+QueryThresholds.propTypes = {
+  value: PropTypes.object,
+  onChange: PropTypes.func,
+};
diff --git a/web/pgadmin/static/js/helpers/ModalProvider.jsx b/web/pgadmin/static/js/helpers/ModalProvider.jsx
index 7e4fe526..d7b0b261 100644
--- a/web/pgadmin/static/js/helpers/ModalProvider.jsx
+++ b/web/pgadmin/static/js/helpers/ModalProvider.jsx
@@ -8,11 +8,13 @@
 //////////////////////////////////////////////////////////////
 
 import { Box, Dialog, DialogContent, DialogTitle, makeStyles, Paper } from '@material-ui/core';
-import React from 'react';
-import {getEpoch} from 'sources/utils';
+import React, { useState } from 'react';
+import { getEpoch } from 'sources/utils';
 import { DefaultButton, PgIconButton, PrimaryButton } from '../components/Buttons';
 import Draggable from 'react-draggable';
 import CloseIcon from '@material-ui/icons/CloseRounded';
+import FullscreenExitIcon from '@material-ui/icons/FullscreenExit';
+import FullscreenIcon from '@material-ui/icons/Fullscreen';
 import CustomPropTypes from '../custom_prop_types';
 import PropTypes from 'prop-types';
 import gettext from 'sources/gettext';
@@ -25,7 +27,7 @@ const ModalContext = React.createContext({});
 export function useModal() {
   return React.useContext(ModalContext);
 }
-const useAlertStyles = makeStyles((theme)=>({
+const useAlertStyles = makeStyles((theme) => ({
   footer: {
     display: 'flex',
     justifyContent: 'flex-end',
@@ -37,11 +39,11 @@ const useAlertStyles = makeStyles((theme)=>({
   }
 }));
 
-function AlertContent({text, confirm, okLabel=gettext('OK'), cancelLabel=gettext('Cancel'), onOkClick, onCancelClick}) {
+function AlertContent({ text, confirm, okLabel = gettext('OK'), cancelLabel = gettext('Cancel'), onOkClick, onCancelClick }) {
   const classes = useAlertStyles();
   return (
     <Box display="flex" flexDirection="column" height="100%">
-      <Box flexGrow="1" p={2}>{typeof(text) == 'string' ? HTMLReactParser(text) : text}</Box>
+      <Box flexGrow="1" p={2}>{typeof (text) == 'string' ? HTMLReactParser(text) : text}</Box>
       <Box className={classes.footer}>
         {confirm &&
           <DefaultButton startIcon={<CloseIcon />} onClick={onCancelClick} >{cancelLabel}</DefaultButton>
@@ -60,10 +62,10 @@ AlertContent.propTypes = {
   cancelLabel: PropTypes.string,
 };
 
-function alert(title, text, onOkClick, okLabel=gettext('OK')){
+function alert(title, text, onOkClick, okLabel = gettext('OK')) {
   // bind the modal provider before calling
-  this.showModal(title, (closeModal)=>{
-    const onOkClickClose = ()=>{
+  this.showModal(title, (closeModal) => {
+    const onOkClickClose = () => {
       onOkClick && onOkClick();
       closeModal();
     };
@@ -73,45 +75,53 @@ function alert(title, text, onOkClick, okLabel=gettext('OK')){
   });
 }
 
-function confirm(title, text, onOkClick, onCancelClick, okLabel=gettext('Yes'), cancelLabel=gettext('No')) {
+function confirm(title, text, onOkClick, onCancelClick, okLabel = gettext('Yes'), cancelLabel = gettext('No')) {
   // bind the modal provider before calling
-  this.showModal(title, (closeModal)=>{
-    const onCancelClickClose = ()=>{
+  this.showModal(title, (closeModal) => {
+    const onCancelClickClose = () => {
       onCancelClick && onCancelClick();
       closeModal();
     };
-    const onOkClickClose = ()=>{
+    const onOkClickClose = () => {
       onOkClick && onOkClick();
       closeModal();
     };
     return (
-      <AlertContent text={text} confirm onOkClick={onOkClickClose} onCancelClick={onCancelClickClose} okLabel={okLabel} cancelLabel={cancelLabel}/>
+      <AlertContent text={text} confirm onOkClick={onOkClickClose} onCancelClick={onCancelClickClose} okLabel={okLabel} cancelLabel={cancelLabel} />
     );
   });
 }
 
-export default function ModalProvider({children}) {
+export default function ModalProvider({ children }) {
   const [modals, setModals] = React.useState([]);
 
-  const showModal = (title, content, modalOptions)=>{
+  const showModal = (title, content, modalOptions) => {
     let id = getEpoch().toString() + Math.random();
-    setModals((prev)=>[...prev, {
+    setModals((prev) => [...prev, {
       id: id,
       title: title,
       content: content,
       ...modalOptions,
     }]);
   };
-  const closeModal = (id)=>{
-    setModals((prev)=>{
-      return prev.filter((o)=>o.id!=id);
+  const closeModal = (id) => {
+    setModals((prev) => {
+      return prev.filter((o) => o.id != id);
     });
   };
+
+  const fullScreenModal = (fullScreen) => {
+    setModals((prev) => [...prev, {
+      fullScreen: fullScreen,
+    }]);
+  };
+
   const modalContextBase = {
     showModal: showModal,
     closeModal: closeModal,
+    fullScreenModal: fullScreenModal
   };
-  const modalContext = React.useMemo(()=>({
+  const modalContext = React.useMemo(() => ({
     ...modalContextBase,
     confirm: confirm.bind(modalContextBase),
     alert: alert.bind(modalContextBase)
@@ -119,8 +129,8 @@ export default function ModalProvider({children}) {
   return (
     <ModalContext.Provider value={modalContext}>
       {children}
-      {modals.map((modalOptions, i)=>(
-        <ModalContainer key={i} {...modalOptions}/>
+      {modals.map((modalOptions, i) => (
+        <ModalContainer key={i} {...modalOptions} />
       ))}
     </ModalContext.Provider>
   );
@@ -133,28 +143,55 @@ ModalProvider.propTypes = {
 function PaperComponent(props) {
   return (
     <Draggable cancel={'[class*="MuiDialogContent-root"]'}>
-      <Paper {...props} style={{minWidth: '600px'}} />
+      <Paper {...props} style={{ minWidth: '600px' }} />
     </Draggable>
   );
 }
 
-function ModalContainer({id, title, content}) {
+const useModalStyles = makeStyles(() => ({
+  titleBar: {
+    display: 'flex',
+    flexGrow: 1
+  },
+  title: {
+    flexGrow: 1
+  },
+}));
+
+function ModalContainer({ id, title, content, fullScreen = false, maxWidth = 'md', isFullWidth = false, showFullScreen = false }) {
   let useModalRef = useModal();
-  let closeModal = ()=>useModalRef.closeModal(id);
+  const classes = useModalStyles();
+  let closeModal = () => useModalRef.closeModal(id);
+  const [isfullScreen, setIsFullScreen] = useState(fullScreen);
+
   return (
     <Theme>
       <Dialog
         open={true}
         onClose={closeModal}
         PaperComponent={PaperComponent}
+        fullScreen={isfullScreen}
+        maxWidth={maxWidth}
+        fullWidth={isFullWidth}
         disableBackdropClick
       >
         <DialogTitle>
-          <Box marginRight="0.25rem">{title}</Box>
-          <Box marginLeft="auto"><PgIconButton title={gettext('Close')} icon={<CloseIcon />} size="xs" noBorder onClick={closeModal}/></Box>
+          <Box className={classes.titleBar}>
+            <Box className={classes.title} marginRight="0.25rem" >{title}</Box>
+            {
+              showFullScreen && !isfullScreen &&
+            <Box marginLeft="auto"><PgIconButton title={gettext('Maximize')} icon={<FullscreenIcon />} size="xs" noBorder onClick={() => { setIsFullScreen(!isfullScreen);  }} /></Box>
+            }
+            {
+              showFullScreen && isfullScreen &&
+              <Box marginLeft="auto"><PgIconButton title={gettext('Minimize')} icon={<FullscreenExitIcon />} size="xs" noBorder onClick={() => { setIsFullScreen(!isfullScreen); }} /></Box>
+            }
+
+            <Box marginLeft="auto"><PgIconButton title={gettext('Close')} icon={<CloseIcon />} size="xs" noBorder onClick={closeModal} /></Box>
+          </Box>
         </DialogTitle>
-        <DialogContent>
-          {content(closeModal)}
+        <DialogContent height="100%">
+          {content(closeModal, isfullScreen)}
         </DialogContent>
       </Dialog>
     </Theme>
@@ -164,4 +201,8 @@ ModalContainer.propTypes = {
   id: PropTypes.string,
   title: CustomPropTypes.children,
   content: PropTypes.func,
+  fullScreen: PropTypes.bool,
+  maxWidth: PropTypes.string,
+  isFullWidth: PropTypes.bool,
+  showFullScreen: PropTypes.bool
 };
diff --git a/web/pgadmin/static/js/helpers/Notifier.jsx b/web/pgadmin/static/js/helpers/Notifier.jsx
index d67faa38..af11762f 100644
--- a/web/pgadmin/static/js/helpers/Notifier.jsx
+++ b/web/pgadmin/static/js/helpers/Notifier.jsx
@@ -8,6 +8,13 @@
 //////////////////////////////////////////////////////////////
 
 import { useSnackbar, SnackbarProvider, SnackbarContent } from 'notistack';
+import { makeStyles } from '@material-ui/core/styles';
+import {Box} from '@material-ui/core';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import { DefaultButton, PrimaryButton } from '../components/Buttons';
+import HTMLReactParser from 'html-react-parser';
+import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
+import PropTypes from 'prop-types';
 import React from 'react';
 import ReactDOM from 'react-dom';
 import Theme from 'sources/Theme';
@@ -76,6 +83,41 @@ FinalNotifyContent.propTypes = {
   children: CustomPropTypes.children,
 };
 
+const useModalStyles = makeStyles((theme)=>({
+  footer: {
+    display: 'flex',
+    justifyContent: 'flex-end',
+    padding: '0.5rem',
+    ...theme.mixins.panelBorder.top,
+  },
+  margin: {
+    marginLeft: '0.25rem',
+  }
+}));
+function AlertContent({text, confirm, okLabel=gettext('OK'), cancelLabel=gettext('Cancel'), onOkClick, onCancelClick}) {
+  const classes = useModalStyles();
+  return (
+    <Box display="flex" flexDirection="column" height="100%">
+      <Box flexGrow="1" p={2}>{HTMLReactParser(text)}</Box>
+      <Box className={classes.footer}>
+        {confirm &&
+          <DefaultButton startIcon={<CloseIcon />} onClick={onCancelClick} >{cancelLabel}</DefaultButton>
+        }
+        <PrimaryButton className={classes.margin} startIcon={<CheckRoundedIcon />} onClick={onOkClick} autoFocus={true} >{okLabel}</PrimaryButton>
+      </Box>
+    </Box>
+  );
+}
+AlertContent.propTypes = {
+  text: PropTypes.string,
+  confirm: PropTypes.bool,
+  onOkClick: PropTypes.func,
+  onCancelClick: PropTypes.func,
+  okLabel: PropTypes.string,
+  cancelLabel: PropTypes.string,
+};
+
+
 var Notifier = {
   success(msg, autoHideDuration = AUTO_HIDE_DURATION) {
     this._callNotify(msg, MESSAGE_TYPE.SUCCESS, autoHideDuration);
@@ -195,11 +237,11 @@ var Notifier = {
     }
     modalRef.confirm(title, text, onOkClick, onCancelClick, okLabel, cancelLabel);
   },
-  showModal(title, content) {
+  showModal: (title, content, modalOptions) => {
     if(!modalInitialized) {
       initializeModalProvider();
     }
-    modalRef.showModal(title, content);
+    modalRef.showModal(title, content, modalOptions);
   }
 };
 
diff --git a/web/pgadmin/static/js/tree/preference_nodes.ts b/web/pgadmin/static/js/tree/preference_nodes.ts
new file mode 100644
index 00000000..605f4a03
--- /dev/null
+++ b/web/pgadmin/static/js/tree/preference_nodes.ts
@@ -0,0 +1,253 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import * as BrowserFS from 'browserfs'
+import pgAdmin from 'sources/pgadmin';
+import _ from 'underscore';
+import { FileType } from 'react-aspen'
+import { findInTree } from './tree';
+
+import { unix } from 'path-fx';
+
+export class ManagePreferenceTreeNodes {
+  constructor(data) {
+    this.tree = {}
+    this.tempTree = new TreeNode(undefined, {});
+    this.treeData = data;
+  }
+
+  public init = (_root: string) => new Promise((res, rej) => {
+    let node = { parent: null, children: [], data: null };
+    this.tree = {};
+    this.tree[_root] = { name: 'root', type: FileType.Directory, metadata: node };
+    res();
+  })
+
+  public updateNode = (_path, _data) => new Promise((res, rej) => {
+    const item = this.findNode(_path);
+    if (item) {
+      item.name = _data.label;
+      item.metadata.data = _data;
+    }
+    res(true);
+  })
+
+  public removeNode = async (_path, _removeOnlyChild) => {
+    const item = this.findNode(_path);
+
+    if (item && item.parentNode) {
+      item.children = [];
+      item.parentNode.children.splice(item.parentNode.children.indexOf(item), 1);
+    }
+    return true;
+  };
+
+  findNode(path) {
+    if (path === null || path === undefined || path.length === 0 || path == '/preferences') {
+      return this.tempTree;
+    }
+    console.log(path)
+    return findInTree(this.tempTree, path);
+  }
+
+  public addNode = (_parent: string, _path: string, _data: []) => new Promise((res, rej) => {
+    _data.type = _data.inode ? FileType.Directory : FileType.File;
+    _data._label = _data.label;
+    _data.label = _.escape(_data.label);
+
+    _data.is_collection = isCollectionNode(_data._type);
+    let nodeData = { parent: _parent, children: _data?.children ? _data.children : [], data: _data };
+
+    let tmpParentNode = this.findNode(_parent);
+    let treeNode = new TreeNode(_data.id, _data, {}, tmpParentNode, nodeData, _data.type);
+
+    if (tmpParentNode !== null && tmpParentNode !== undefined) tmpParentNode.children.push(treeNode);
+
+    res(treeNode);
+  })
+
+  public readNode = (_path: string) => new Promise<string[]>((res, rej) => {
+    let temp_tree_path = _path,
+      node = this.findNode(_path),
+      base_url = '/preferences/';
+    node.children = [];
+
+    if (node && node.children.length > 0) {
+      if (!node.type === FileType.File) {
+        rej("It's a leaf node")
+      }
+      else {
+        if (node?.children.length != 0) res(node.children)
+      }
+    }
+
+    var self = this;
+
+    async function loadData() {
+      const Path = BrowserFS.BFSRequire('path')
+      const fill = async (tree) => {
+        //remove this is code clenup
+        for (let idx in tree) {
+          const _node = tree[idx]
+          const _pathl = Path.join(_path, _node.id)
+          await self.addNode(temp_tree_path, _pathl, _node);
+        }
+      }
+
+      if (node && !_.isUndefined(node.id)) {
+        let _data = self.treeData.find((el) => el.id == node.id);
+        // console.log('Inside sub nodes')
+
+        let subNodes = [];
+
+        _data.childrenNodes.forEach(element => {
+          subNodes.push(element)
+        });
+
+        await fill(subNodes);
+      } else {
+        await fill(self.treeData);
+      }
+
+      if (node?.children.length > 0) return res(node.children);
+      else return res(null);
+
+    }
+    loadData();
+  })
+
+}
+
+
+
+export class TreeNode {
+  constructor(id, data, domNode, parent, metadata, type) {
+    this.id = id;
+    this.data = data;
+    this.setParent(parent);
+    this.children = [];
+    this.domNode = domNode;
+    this.metadata = metadata;
+    this.name = metadata ? metadata.data.label : "";
+    this.type = type ? type : undefined;
+  }
+
+  hasParent() {
+    return this.parentNode !== null && this.parentNode !== undefined;
+  }
+
+  parent() {
+    return this.parentNode;
+  }
+
+  setParent(parent) {
+    this.parentNode = parent;
+    this.path = this.id;
+    if (this.id)
+      if (parent !== null && parent !== undefined && parent.path !== undefined) {
+        this.path = parent.path + '/' + this.id;
+      } else {
+        this.path = '/preferences/' + this.id;
+      }
+  }
+
+  getData() {
+    if (this.data === undefined) {
+      return undefined;
+    } else if (this.data === null) {
+      return null;
+    }
+    return Object.assign({}, this.data);
+  }
+
+  getHtmlIdentifier() {
+    return this.domNode;
+  }
+
+  /*
+   * Find the ancestor with matches this condition
+   */
+  ancestorNode(condition) {
+    let node = this;
+
+    while (node.hasParent()) {
+      node = node.parent();
+      if (condition(node)) {
+        return node;
+      }
+    }
+
+    return null;
+  }
+
+  /**
+   * Given a condition returns true if the current node
+   * or any of the parent nodes condition result is true
+   */
+  anyFamilyMember(condition) {
+    if (condition(this)) {
+      return true;
+    }
+
+    return this.ancestorNode(condition) !== null;
+  }
+  anyParent(condition) {
+    return this.ancestorNode(condition) !== null;
+  }
+
+  reload(tree) {
+    return new Promise((resolve) => {
+      this.unload(tree)
+        .then(() => {
+          tree.setInode(this.domNode);
+          tree.deselect(this.domNode);
+          setTimeout(() => {
+            tree.selectNode(this.domNode);
+          }, 0);
+          resolve();
+        });
+    });
+  }
+
+  unload(tree) {
+    return new Promise((resolve, reject) => {
+      this.children = [];
+      tree.unload(this.domNode)
+        .then(
+          () => {
+            resolve(true);
+          },
+          () => {
+            reject();
+          });
+    });
+  }
+
+
+  open(tree, suppressNoDom) {
+    return new Promise((resolve, reject) => {
+      if (suppressNoDom && (this.domNode == null || typeof (this.domNode) === 'undefined')) {
+        resolve(true);
+      } else if (tree.isOpen(this.domNode)) {
+        resolve(true);
+      } else {
+        tree.open(this.domNode).then(val => resolve(true), err => reject(true));
+      }
+    });
+  }
+
+}
+
+export function isCollectionNode(node) {
+  if (pgAdmin.Browser.Nodes && node in pgAdmin.Browser.Nodes) {
+    if (pgAdmin.Browser.Nodes[node].is_collection !== undefined) return pgAdmin.Browser.Nodes[node].is_collection;
+    else return false;
+  }
+  return false;
+}
diff --git a/web/pgadmin/static/js/tree/preferences_tree.tsx b/web/pgadmin/static/js/tree/preferences_tree.tsx
new file mode 100644
index 00000000..f19db9de
--- /dev/null
+++ b/web/pgadmin/static/js/tree/preferences_tree.tsx
@@ -0,0 +1,53 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import * as React from 'react';
+import { render } from 'react-dom';
+import { FileTreeX, TreeModelX } from 'pgadmin4-tree';
+import {Tree} from './tree';
+
+import { IBasicFileSystemHost } from 'react-aspen';
+import { ManagePreferenceTreeNodes } from './preference_nodes';
+
+var initPreferencesTree = async (pgBrowser, container, data) => {
+  const MOUNT_POINT = '/preferences'
+
+  // Setup host
+  let ptree = new ManagePreferenceTreeNodes(data);
+
+  // Init Tree with the Tree Parent node '/browser'
+  ptree.init(MOUNT_POINT);
+  const host: IBasicFileSystemHost = {
+    pathStyle: 'unix',
+    getItems: async (path) => {
+      return ptree.readNode(path);
+    },
+  }
+
+  const pTreeModelX = new TreeModelX(host, MOUNT_POINT)
+
+  const itemHandle = function onReady(handler) {
+    // Initialize pgBrowser Tree
+    pgBrowser.ptree = new Tree(handler, ptree, pgBrowser, false);
+    return true;
+  }
+
+  await pTreeModelX.root.ensureLoaded()
+
+  // Render Browser Tree
+  await render(
+      <FileTreeX model={pTreeModelX}
+        onReady={itemHandle} />
+     , container);
+}
+
+module.exports = {
+    initPreferencesTree: initPreferencesTree,
+};
+
